# -*- coding: utf-8 -*-

class WorldOfDarkness < DiceBot
  setPrefixes(['\d+st.*'])

  def initialize
    super
    @successDice = 0
    @botchDice = 0
    @rerollDice = 0

  end
  def gameName
    'ワールドオブダークネス'
  end
  
  def gameType
    "WorldOfDarkness"
  end
  
  def getHelpMessage
    return <<INFO_MESSAGE_TEXT
・判定コマンド(xSTn+y or xSTSn+y)
　(ダイス個数)ST(難易度)+(自動成功)
　(ダイス個数)STS(難易度)+(自動成功)　※出目10で振り足し
　(ダイス個数)STA(難易度)+(自動成功)　※出目10は2成功。振り足し無。[20thルール]

　難易度=省略時6
　自動成功=省略時0
INFO_MESSAGE_TEXT
  end

  def rollDiceCommand(command)
    result = rollWorldOfDarkness(command)
    return result
  end

  def rollWorldOfDarkness(string)
    diceCount = 1
    difficulty = 6
    automaticSuccess = 0
	isReroll = false
	is20A = false

    output = ''

	if (/STS/ =~ string)
        string = string.gsub(/(\d+)STS(\d*)([^\d\s][\+\-\d]+)/i) {"#{$1}STS#{$2}[#{$3}]"}
        string = string.gsub(/(\d+)STS(\d*)/i) {"#{$1}STS#{$2}"} unless $3
		isReroll = true
	elsif (/STA/ =~ string)
        string = string.gsub(/(\d+)STA(\d*)([^\d\s][\+\-\d]+)/i) {"#{$1}STA#{$2}[#{$3}]"}
        string = string.gsub(/(\d+)STA(\d*)/i) {"#{$1}STA#{$2}"} unless $3
		is20A = true
    else
        string = string.gsub(/(\d+)ST(\d*)([^\d\s][\+\-\d]+)/i) {"#{$1}ST#{$2}[#{$3}]"}
        string = string.gsub(/(\d+)ST(\d*)/i) {"#{$1}ST#{$2}"} unless $3
	end

    diceCount = $1.to_i if $1
    difficulty = $2.to_i if $2
    difficulty = 6 if difficulty < 2
    automaticSuccess = $3.to_i if $3

  	output = 'DicePool=' + diceCount.to_s + ', Difficulty=' + difficulty.to_s + ', AutomaticSuccess=' + automaticSuccess.to_s

    @successDice = 0
    @botchDice = 0
    @rerollDice = 0

    output += rollDiceWorldOfDarknessSpecial(diceCount, difficulty, isReroll, true, is20A)
	while @rerollDice > 0 do
		diceCount = @rerollDice
		@rerollDice = 0
	    output += rollDiceWorldOfDarknessSpecial(diceCount, difficulty, isReroll, false, is20A)
	end

	successResult = @successDice - @botchDice
	if successResult < 0
		successResult = 0
	end
	successResult += automaticSuccess

    if successResult > 0
    	output += " ＞ 成功数" + successResult.to_s
    else
	    if @successDice == 0 && @botchDice > 0
	    	output += " ＞ 大失敗"
	    else
	    	output += " ＞ 失敗"
	    end
    end

    return output
  end

  def rollDiceWorldOfDarknessSpecial(diceCount, difficulty, isReroll, isFirst, is20A)
	diceType = 10
    diceResults = Array.new(diceCount)

    diceCount.times do |i|
       	dice_now, = roll(1, diceType)

		if dice_now == diceType
			if is20A == true
			   	@successDice += 2
			else
			   	@successDice += 1
			end
			if isReroll == true
	           	@rerollDice += 1
			end
		else
			if dice_now >= difficulty
			   	@successDice += 1
			end
			if dice_now == 1 && isFirst == true
			   @botchDice += 1
			end
		end

       	diceResults[i] = dice_now
    end 

	diceResults.sort!

	result = " ＞ "
    diceResults.each do |diceResult|
       result += diceResult.to_s  + ','
    end

	result = result.chop

	return result
  end
end
